--[[
	oUF_WTF
	Author:	 Aerials
--]]

-- Options
local showRaid = 1 -- 1 shows raid frames
local showPartyinRaid = 1 -- 1 shows party while in raid (for if you have showRaid set to 0 and want party shown
local healMode = 1 -- 1 sets to heal mode (adds mana bars to raid, changes raid layout. [this does nothing yet, still implimenting it].
local NameText = 1  -- 1 shows name text fields for target, party.
local hidebuffs = 1  -- 1 hides default blizzard buff frame and shows oUF Player Buffs (anything else does opposite).
local RepBar = 1 --set to 1 to show rep and XP Bar (Rep only at 80) or 0 to only show XP Bar (nothing at 80)
local scaleP = 0.7 -- change the scale for party (also changes font size and anchor distance, so adjust as needed)
local scalePl = 1 -- scale player
local scaleT = 1 -- scale target
local scaleR = 1 -- scale raid

local XPRepXPos = 0			--set XP and Rep Bar X Position
local XPRepYPos = 2			--set XP and Rep Bar Y Position
local XPRepWid = 482			--set XP and Rep Bar Width
local XPRepHei = 12			--set XP and Rep Bar Height
local XPRepAFrom = "BOTTOM"		--set Point on XP and Rep Bar use in anchor
local XPRepAFrame = UIParent		--set frame XP and Rep Bar will anchor to
local XPRepATo = "BOTTOM"		--set Point on anchor frame to use in anchor
local XPRepHalfWid = 241	--don't bother with this.

-- locals
local select = select
local UnitClass = UnitClass
local UnitIsDead = UnitIsDead
local UnitIsPVP = UnitIsPVP
local UnitIsGhost = UnitIsGhost
local UnitIsPlayer = UnitIsPlayer
local UnitReaction = UnitReaction
local UnitIsConnected = UnitIsConnected
local UnitCreatureType = UnitCreatureType
local UnitClassification = UnitClassification
local UnitReactionColor = UnitReactionColor
local RAID_CLASS_COLORS = RAID_CLASS_COLORS
local texture = [=[Interface\AddOns\oUF_WTF\Media\texture]=]
local backdrop = {bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=], insets = {top = -1, left = -1, bottom = -1, right = -1},}
local font = "Interface\\AddOns\\oUF_WTF\\Media\\mvboli.ttf"
local fontsize = 12
local raidfontsize = 10
local partyfontsize = 16
local bufftex = "Interface\\AddOns\\oUF_WTF\\Media\\border"
local borderDebuffHigh = texture
local playerClass = select(2, UnitClass("player"))

-- change some colors
oUF.colors.happiness = {
	[1] = {182/225, 34/255, 32/255},	-- unhappy
	[2] = {220/225, 180/225, 52/225},	-- content
	[3] = {143/255, 194/255, 32/255},	-- happy
}
oUF.colors.power = {
	['MANA']            = { 95/255, 155/255, 255/255 }, 
	['RAGE']            = { 250/255,  75/255,  60/255 }, 
	['FOCUS']           = { 255/255, 209/255,  71/255 },
	['ENERGY']          = { 200/255, 255/255, 200/255 }, 
	['RUNIC_POWER']     = {   0/255, 209/255, 255/255 },
	["AMMOSLOT"]		= { 200/255, 255/255, 200/255 },
	["FUEL"]			= { 250/255,  75/255,  60/255 },
		["POWER_TYPE_STEAM"] = {0.55, 0.57, 0.61},
		["POWER_TYPE_PYRITE"] = {0.60, 0.09, 0.17},	
}
local colors = {
	class ={
	["DEATHKNIGHT"] = { 196/255,  30/255,  60/255 },
	["DRUID"]       = { 255/255, 125/255,  10/255 },
	["HUNTER"]      = { 171/255, 214/255, 116/255 },
	["MAGE"]        = { 104/255, 205/255, 255/255 },
	["PALADIN"]     = { 245/255, 140/255, 186/255 },
	["PRIEST"]      = { 212/255, 212/255, 212/255 },
	["ROGUE"]       = { 255/255, 243/255,  82/255 },
	["SHAMAN"]      = {  10/255, 164/255, 250/255 },	
	["WARLOCK"]     = { 148/255, 130/255, 201/255 },
	["WARRIOR"]     = { 199/255, 156/255, 110/255 },
	},
}

runecolor = {
		{ 0.77, 0.12, 0.23  },
		{ 0.9, 0.7, 0.1 },
		{ 0, 0.4, 0.7 },
		{ 0.8, 0.1, 1 },
}

setmetatable(colors.class, {
	__index = function(self, key)
		return { 0.78, 0.61, 0.43 }
	end
})
local GetClassColor = function(unit)
	return unpack(colors.class[select(2, UnitClass(unit))])
end

-- health color gradient
oUF.colors.smooth = {0.69, 0.31, 0.31, 0.65, 0.63, 0.35, 0.15, 0.15, 0.15}
local color_rb = 1.00
local color_gb = 1.00
local color_bb = 1.00
local alpha_fb = 1.00
local corb = 1
local cogb = 0
local cobb = 0

-- right click
local menu = function(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub("(.)", string.upper, 1)

	if(unit == "party" or unit == "partypet") then
		ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..self.id.."DropDown"], "cursor", 0, 0)
	elseif(_G[cunit.."FrameDropDown"]) then
		ToggleDropDownMenu(1, nil, _G[cunit.."FrameDropDown"], "cursor", 0, 0)
	end
end

-- reformat everything above 9999, i.e. 10000 -> 10k and reformat everything above 999 in raidframes
local numberize = function(v)
	if v <= 9999 then return v end
	if v >= 1000000 then
		local value = string.format("%.1fm", v/1000000)
		return value
	elseif v >= 10000 then
		local value = string.format("%.1fk", v/1000)
		return value
	end
end
local numberize_raid = function(v)
	if v <= 999 then return v end
	if v >= 1000000 then
		local value = string.format("%.1fm", v/1000000)
		return value
	elseif v >= 1000 then
		local value = string.format("%.1fk", v/1000)
		return value
	end
end

-- level update
local updateLevel = function(self, unit, name)
	local lvl = UnitLevel(unit)
	local typ = UnitClassification(unit)
	
	local colord = GetQuestDifficultyColor(lvl)  
        
	if lvl <= 0 then	lvl = "??" end
            
	if typ=="worldboss" then
	    self.Level:SetText("|cffff0000"..lvl.."b|r")
		self.Level:SetTextColor(colord.r, colord.g, colord.b)
	elseif typ=="rareelite" then
	    self.Level:SetText(lvl.."r+")
		self.Level:SetTextColor(colord.r, colord.g, colord.b)
	elseif typ=="elite" then
	    self.Level:SetText(lvl.."+")
		self.Level:SetTextColor(colord.r, colord.g, colord.b)
	elseif typ=="rare" then
		self.Level:SetText(lvl.."r")
		self.Level:SetTextColor(colord.r, colord.g, colord.b)
	else
		if UnitIsConnected(unit) == 1 then
			self.Level:SetText(lvl)
		self.Level:SetTextColor(colord.r, colord.g, colord.b)
		else
			self.Level:SetText("??")
		end
	end
end

-- name update
local updateName = function(self, event, unit, name)
	if(self.unit ~= unit) then return end

	local name = UnitName(unit)
		self.Name:SetText(name)
	if unit=="targettarget" then
		local totName = UnitName(unit)
		local pName = UnitName("player")
		self.Name:SetTextColor(GetClassColor(unit))		
	else
		self.Name:SetTextColor(GetClassColor(unit))
	end
	if unit=="focustarget" then
		local ftName = UnitName(unit)
		local pName = UnitName("player")
		self.Name:SetTextColor(GetClassColor(unit))		
	else
		self.Name:SetTextColor(GetClassColor(unit))
	end
	if unit=="target" then -- Show level value on targets only
		updateLevel(self, unit, name)
	else
		updateLevel(self, unit, name)
	end
    if(self:GetParent():GetName():match"oUF_Raid") then
	self.Name:SetTextColor(GetClassColor(unit))
    end
end

-- health update
local updateHealth = function(self, event, unit, bar, min, max)  
    local cur, maxhp = min, max
    local missing = maxhp-cur
    local d = floor(cur/maxhp*100)
	if(UnitIsDead(unit)) then
		bar:SetValue(0)
		bar.value:SetText"DEAD"
	elseif(UnitIsGhost(unit)) then
		bar:SetValue(0)
		bar.value:SetText"GHOST"
	elseif(not UnitIsConnected(unit)) then
		bar.value:SetText"D/C"
    	elseif(unit == "player") then
		bar.value:SetText(d.."%")
	elseif(unit == "targettarget") then
		bar.value:SetText(d.."%")
	elseif(unit == "focustarget") then
		bar.value:SetText(d.."%")
	elseif(unit == "focus") then
		bar.value:SetText(d.."%")
    	elseif(unit == "target") then
		bar.value:SetText(d.."%")
	elseif(self:GetParent():GetName():match"oUF_Raid") then
		if(d < 100) then
			bar.value:SetText(d.."%")
		else
			bar.value:SetText(" ")
		end
	elseif(self:GetParent():GetName():match"oUF_Party") then
		if(self:GetAttribute('unitsuffix') == 'pet') then
			bar.value:SetText(d.."%")
		elseif(self:GetAttribute('unitsuffix') == 'target') then
			bar.value:SetText(d.."%")
		else
			bar.value:SetText(d.."%")
		end
	elseif(min == max) then
        	if unit == "pet" then
			bar.value:SetText(d.."%") -- just here if otherwise wanted
		elseif unit == "pettarget" then
			bar.value:SetText(d.."%") -- just here if otherwise wanted
		else
			bar.value:SetText(" ")
		end
	else
        	if((max-min) < max) then
			if unit == "pet" then
				bar.value:SetText(d.."%") -- negative values as for party, just here if otherwise wanted
			elseif unit == "pettarget" then
				bar.value:SetText(d.."%") -- negative values as for party, just here if otherwise wanted
			else
				bar.value:SetText(d.."%") -- this makes negative values (easier as a healer)
			end
	    	end
	end

    self:UNIT_NAME_UPDATE(event, unit)
end

-- druid mana

local DMana = CreateFrame("StatusBar", nil, self)
DMana:SetStatusBarTexture(texture)
DMana:SetBackdrop({bgFile = texture, insets = {top = 0, left = 0, bottom = 0, right = 0},})
DMana:SetBackdropColor(0, 0, 0)
DMana:SetStatusBarColor(unpack(oUF.colors.power["MANA"]))


local function updateDMana(self, event, unit)
	if(unit and unit ~= self.unit) then return end
	local DMmin, DMmax = UnitPower("player", 0), UnitPowerMax("player", 0)
	
	DMana:SetMinMaxValues(0, DMmax)
	DMana:SetValue(DMmin)
	local ptype = UnitPowerType("player")
	if ptype == 0 then
		DMana:Hide()
	else
		DMana:Show()
	end
end

oUF.TagEvents['[druidpower]'] = 'UNIT_MANA UPDATE_SHAPESHIFT_FORM'
oUF.Tags['[druidpower]'] = function(unit)
	local min, max = UnitPower(unit, 0), UnitPowerMax(unit, 0)
	return UnitPowerType(unit) ~= 0 and format('|cfdcdcdcf%d - %d%%|r', min, math.floor(min / max * 100))

end



local function updateDruidPower(self, event, unit)
	if(unit and unit ~= self.unit) then return end
	local mana = UnitPowerType('player') == 0
	local min, max = UnitPower('player', mana and 3 or 0), UnitPowerMax('player', mana and 3 or 0)

end

function round(num, idp)
  if idp and idp>0 then
    local mult = 10^idp
    return math.floor(num * mult + 0.5) / mult
  end
  return math.floor(num + 0.5)
end

-- update power
local updatePower = function(self, event, unit, bar, min, max)
	local _, ptype = UnitPowerType(unit)
	local colorz = oUF.colors.power[ptype]
	local dp =(round(min/max, 2)*100)
	if(min == 0 or max == 0 or not UnitIsConnected(unit)) then
		bar.value:SetText()
		bar:SetValue(0)
	elseif(UnitIsDead(unit) or UnitIsGhost(unit)) then
		bar:SetValue(0)
	else
		bar.value:SetText(floor(min / max * 100).."%")
	end
	
	if unit=="player" or (self:GetParent():GetName():match"oUF_Party") then
		if(self:GetParent():GetName():match"oUF_Party") and (self:GetAttribute('unitsuffix') == 'pet') or (self:GetAttribute('unitsuffix') == 'target') then
			bar.value:SetTextColor(0, 1, 0)
		else
			bar.value:SetTextColor(colorz[1], colorz[2], colorz[3])
		end
	else
		bar.value:SetTextColor(0, 1, 0)
	end
	-- hide power bar for npcs without power
	if unit=="target" then
			if ( UnitIsPlayer("target") ) then
			self.Power:Show()
			self.Power.bg:SetAlpha(0.6)
			else	
			if ( UnitPowerType("target") ~= 0 ) then
				self.Power:Show()
				self.Power.bg:SetAlpha(0.6)
			end
		end
	end	
end

-- aura cancel on right click
local function onMouseUp(self, button)
	if(button == 'RightButton') then
		CancelUnitBuff(self.frame.unit, self:GetID(), self.filter)
	end
end

-- aura reskin
local auraIcon = function(self, button, icons)
	icons.showDebuffType = true -- show debuff border type color  
	
	button.icon:SetTexCoord(.07, .93, .07, .93)
	button.icon:SetPoint("TOPLEFT", button, "TOPLEFT", 1, -1)
	button.icon:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -1, 1)
	
	button.overlay:SetTexture(bufftex)
	button.overlay:SetTexCoord(0,1,0,1)
	button.overlay.Hide = function(self) self:SetVertexColor(1, 1, 1) end
	
	button.cd:SetReverse()
	button.cd:SetPoint("TOPLEFT", button, "TOPLEFT", 2, -2) 
	button.cd:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 2) 
	button:SetScript('OnMouseUp', onMouseUp)    
end

local UpdateCPoints = function(self, event, unit)
	if unit == PlayerFrame.unit and unit ~= self.CPoints.unit then
		self.CPoints.unit = unit
	end
end

if hidebuffs == 1 then
	BuffFrame:Hide()
end

----------------------------
-- the layout starts here --
----------------------------
-- set up some base stuffs
local func = function(self, unit)
	self.menu = menu -- Enable the menus
	self:SetScript("OnEnter", UnitFrame_OnEnter)
	self:SetScript("OnLeave", UnitFrame_OnLeave)
	self:RegisterForClicks"anyup"
	self:SetAttribute("*type2", "menu")
	self:SetFrameStrata("MEDIUM")
	self:SetFrameLevel(0)
	self.disallowVehicleSwap = true  --comment this to allow vehicle swap
-- backdrop
	self.BG = self:CreateTexture("bg", "BACKGROUND")
	self.BG:SetAllPoints(self)
	self.BG:SetTexture(texture)
	self.BG:SetVertexColor(0, 0, 0, 0.8)
-- testing for icons
	self.ICONS = CreateFrame("Frame", nil, self)
	self.ICONS:SetFrameStrata("MEDIUM")
	self.ICONS:SetFrameLevel(10)
-- healthbar
	self.Health = CreateFrame"StatusBar"
   	self.Health:SetParent(self)
	self.Health:SetFrameStrata("MEDIUM")
	self.Health:SetFrameLevel(3)
	self.Health:SetOrientation("VERTICAL")
	self.Health.frequentUpdates = true
-- healthbar background
	self.Health.bg = self.Health:CreateTexture(nil, "BORDER")
	self.Health.bg:SetAllPoints(self.Health)
	self.Health.bg:SetAlpha(0.40)
-- healthbar text
	self.Health.value = self.Health:CreateFontString(nil, "OVERLAY")
	self.Health.value:SetTextColor(1,1,1)
	self.Health.value:SetShadowOffset(1, -1) 
-- powerbar
	self.Power = CreateFrame"StatusBar"
	self.Power:SetParent(self)
	self.Power.frequentUpdates = true
	self.Power:SetFrameStrata("MEDIUM")
	self.Power:SetFrameLevel(3)
	self.Power:SetOrientation("VERTICAL")
-- powerbar background
	self.Power.bg = self.Power:CreateTexture(nil, "BORDER")
	self.Power.bg:SetAllPoints(self.Power)
	self.Power.bg:SetAlpha(0.50)  
-- powerbar text
	self.Power.value = self.Power:CreateFontString(nil, "OVERLAY")
	self.Power.value:SetTextColor(1,1,1)
	self.Power.value:SetShadowOffset(1, -1)
   	self.Power.value:Show()
-- powerbar functions
	self.Power.colorTapping = true 
	self.Power.colorDisconnected = true 
	self.Power.colorClass = true 
	self.Power.colorPower = true 
	self.Power.colorHappiness = false 
-- names
	self.Name = self.Health:CreateFontString(nil, "OVERLAY")
	self.Name:SetShadowOffset(1, -1)
	self.UNIT_NAME_UPDATE = updateName
-- level
	self.Level = self.Health:CreateFontString(nil, "OVERLAY")
	self.Level:SetTextColor(1,1,1)
	self.Level:SetShadowOffset(1, -1)
	self.UNIT_LEVEL = updateLevel
-- oUF Tags Holder Frame (working on removing this pos)

	self.Name:Hide()
	self.Name:SetParent(self.Health)
	self.Level:SetParent(self.Health)
	self.Power.value:SetParent(self.Health)
	self.Health.value:SetParent(self.Health)
-- Combat Feedback support	
-- Combat Feedback support		
	local cbft = self.Health:CreateFontString(nil, "OVERLAY")
		cbft:SetFontObject(GameFontNormal)
		self.CombatFeedbackText = cbft	
		self.CombatFeedbackText:SetParent(self.Health)	

--FONTS
	if unit=='player' or unit=='target' then
		self.Health.value:SetFont(font, fontsize, "OUTLINE")
		self.Power.value:SetFont(font, fontsize, "OUTLINE")
		self.Name:SetFont(font, fontsize, "OUTLINE")
		self.CombatFeedbackText:SetFont(font, 18, "OUTLINE")
		self.Level:SetFont(font, fontsize, "OUTLINE")
	elseif(self:GetParent():GetName():match"oUF_Party") then
		self.Health.value:SetFont(font, partyfontsize, "OUTLINE")
		self.Power.value:SetFont(font, partyfontsize, "OUTLINE")
		self.Name:SetFont(font, partyfontsize, "OUTLINE")
		self.CombatFeedbackText:SetFont(font, 22, "OUTLINE")
		self.Level:SetFont(font, partyfontsize, "OUTLINE")
	elseif (self:GetParent():GetName():match"oUF_Raid") then
		self.Health.value:SetFont(font, 6, "OUTLINE")
		self.Power.value:SetFont(font, 6, "OUTLINE")
		self.Name:SetFont(font, 6, "OUTLINE")
		self.CombatFeedbackText:SetFont(font, 6, "OUTLINE")
		self.Level:SetFont(font, 6, "OUTLINE")
	else
		self.Health.value:SetFont(font, 8, "OUTLINE")
		self.Power.value:SetFont(font, 8, "OUTLINE")
		self.Name:SetFont(font, 8, "OUTLINE")
		self.CombatFeedbackText:SetFont(font, 8, "OUTLINE")
		self.Level:SetFont(font, 8, "OUTLINE")
	end

-- oUF_SpellRange fading and oUF_Smooth support for all frames
		if(unit) or (self:GetParent():GetName():match"oUF_Raid") or (self:GetParent():GetName():match"oUF_Party") then 
		self.SpellRange = true; -- fadeout if units are out of range
		self.inRangeAlpha = 1.0; -- Frame alpha when in range
		self.outsideRangeAlpha = 0.3; -- Frame alpha when out of range
		self.Power.Smooth = true
		self.Health.Smooth = true
		end
-- health color gradient for player, party, raid, pet	
	if unit=="player" or unit=="pet" or unit=="pettarget" or (self:GetParent():GetName():match"oUF_Party") then	
		self.Health.colorSmooth = true		
	end
-- oUF_DebuffHighlight support - border highlight
	if unit=="player" or unit=="target" or unit=="pet" or unit=="pettarget" or (self:GetParent():GetName():match"oUF_Party") then
		self.DebuffHighlight = self:CreateTexture(nil, "OVERLAY")
		self.DebuffHighlight:SetPoint("TOPLEFT",self,"TOPLEFT",-4,4)
		self.DebuffHighlight:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",4,-4)
		self.DebuffHighlight:SetTexture(texture)
		self.DebuffHighlight:SetVertexColor(0, 0, 0, 0)
		self.DebuffHighlight:SetBlendMode("ADD")
		self.DebuffHighlightAlpha = 0.7
		self.DebuffHighlightFilter = false
	else
		self.DebuffHighlight = self:CreateTexture(nil, "OVERLAY")
		self.DebuffHighlight:SetPoint("TOPLEFT",self,"TOPLEFT",-2,2)
		self.DebuffHighlight:SetPoint("BOTTOMRIGHT",self,"BOTTOMRIGHT",2,-2)
		self.DebuffHighlight:SetTexture(texture)
		self.DebuffHighlight:SetVertexColor(0, 0, 0, 0)
		self.DebuffHighlight:SetBlendMode("ADD")
		self.DebuffHighlightAlpha = 0.7
		self.DebuffHighlightFilter = false
	end
-- health
--	self.Health:SetPoint("TOP", self, "TOP", 0, 0)
	self.Health:SetStatusBarTexture(texture)
	self.Health.bg:SetTexture(texture)
	self.Health:SetStatusBarColor(0.84, 0.76, 0.53)
-- power 
	self.Power:SetStatusBarTexture(texture)	
	self.Power:SetAlpha(0.8)
	self.Power.bg:SetTexture(texture)
	self.Power.value:SetJustifyH("LEFT")
-- name
--	self.Name:Show()
	self.Name:SetJustifyH("LEFT")
-- level
	self.Level:SetJustifyH("LEFT")
-- other
	self.ignoreBanzai = false
	self.Auras = CreateFrame("Frame", nil, self)
	self.Debuffs = CreateFrame("Frame", nil, self)
	self.Enchant = CreateFrame("Frame", nil, self)

-- Portrait
	local portrait = CreateFrame("PlayerModel", nil, self)
	if unit=="player" or unit=="target" or unit=="targettarget" or unit=="focustarget" or unit=="focus" or unit=="pet" or unit=="pettarget" or (self:GetParent():GetName():match"oUF_Party") or (unit and unit:find('party%dtarget')) then

		portrait:SetScript("OnShow", function(self) self:SetCamera(0) end)
		portrait.type = "3D"
		self.Portrait = portrait
		portrait:SetFrameStrata("MEDIUM")		
		portrait:SetFrameLevel(2)

		self.PortraitOverlay = CreateFrame("StatusBar", self:GetName().."_PortraitOverlay", self)
		self.PortraitOverlay:SetFrameStrata("MEDIUM")
		self.PortraitOverlay:SetFrameLevel(1)
		self.PortraitOverlay:SetHeight(self.Portrait:GetHeight())
		self.PortraitOverlay:SetPoint("TOPLEFT", self.Portrait, "TOPLEFT", 0, 0)
		self.PortraitOverlay:SetPoint("BOTTOMRIGHT", self.Portrait, "BOTTOMRIGHT", 0, 0)
		self.PortraitOverlay:SetStatusBarTexture(texture)
		self.PortraitOverlay:SetStatusBarColor(0.25, 0.25, 0.25, 0.5)
	end

	-- raid target icons for all frames
	if unit=="player" or unit=="target" or unit=="targettarget" or unit=="focustarget" or unit=="focus" or unit=="pet" or unit=="pettarget" or (self:GetParent():GetName():match"oUF_Party") or (self:GetParent():GetName():match"oUF_Raid") then
		self.RaidIcon = self.Health:CreateTexture(nil, "OVERLAY")
		self.RaidIcon:SetHeight(24)
		self.RaidIcon:SetWidth(24)
		self.RaidIcon:SetTexture"Interface\\TargetingFrame\\UI-RaidTargetingIcons"
		self.RaidIcon:SetParent(self.ICONS)
	end


-- ------------------------------------
-- player & target & party
-- ------------------------------------
	if unit=="player" or unit=="target" or (self:GetParent():GetName():match"oUF_Party") then
		if(self:GetParent():GetName():match"oUF_Party") and (self:GetAttribute('unitsuffix') == 'pet') or (self:GetAttribute('unitsuffix') == 'target') then
			self.Level:Hide()
			self.Health:SetPoint("TOPLEFT", self, "TOPLEFT", 2, -2)
			self.Health.value:Hide()
			self.Power.value:Hide()
	--		self.Name:Hide()
			if (self:GetAttribute('unitsuffix') == 'pet') then
				self.Health.colorTapping = false
				self.Health.colorClass = false
				self.Health.colorReaction = true
				self.Health.colorDisconnected = false
				self.PostUpdateHealth = updateHealth
				self.PostUpdatePower = updatePower -- let the colors be
			else
				self.Health.colorTapping = true
				self.Health.colorClass = true
				self.Health.colorReaction = true
				self.Health.colorDisconnected = true
				self.PostUpdateHealth = updateHealth
				self.PostUpdatePower = updatePower -- let the colors be
			end
			self:SetWidth(14)
			self:SetHeight(74)
			self.Health:SetWidth(10)
			self.Health:SetHeight(70)
			self.CombatFeedbackText:Hide()
			self.Power:Hide()
	-- auras
			self.Debuffs:Hide()
			self.Auras:Hide()
			self.MoveableFrames = true
		else
			self:SetWidth(85)
			self:SetHeight(150)
	-- Portrait
			self.Portrait:SetPoint("TOPLEFT", self, "TOPLEFT", 12, -2)
			self.Portrait:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -12, 2)
	-- main frame
	--		self.Level:Hide()
			self.Level:SetPoint("TOPLEFT", self.Portrait, "BOTTOMLEFT", 1, 20)
			self.Level:SetPoint("BOTTOMRIGHT", self.Portrait, "BOTTOMRIGHT", -1, 1)
			self.Health:SetPoint("TOPLEFT", self, "TOPLEFT", 2, -2)
			self.Health:SetPoint("BOTTOMRIGHT", self, "BOTTOMLEFT", 10, 2)
	--		self.Health.value:Hide()
			self.Health.value:SetPoint("TOPLEFT", self.Portrait, "TOPLEFT", 0, 0)
	--		self.Power.value:Hide()
			self.Power.value:SetPoint("TOPLEFT", self.Portrait, "TOPLEFT", 0, -13)
			if unit=="target" or (self:GetParent():GetName():match"oUF_Party") then
				if NameText==1 then
					self.Name:Show()
				else
					self.Name:Hide()
				end
			end
			self.Name:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 1, 0)
			self.Name:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -1, -18)
			self.RaidIcon:SetPoint("LEFT", self.Portrait, "LEFT", 2, 0)


	-- health
			self.Health.colorTapping = false
			self.Health.colorClass = true
			self.Health.colorReaction = true
			self.Health.colorDisconnected = true
			self.Health:SetWidth(5)
			self.Health:SetHeight(150)
			self.PostUpdateHealth = updateHealth

	-- mana
			self.Power:SetPoint("TOPRIGHT", self, "TOPRIGHT", -2, -2)
			self.Power:SetPoint("BOTTOMLEFT", self, "BOTTOMRIGHT", -10, 2)
			self.Power:SetWidth(5)
			self.Power:SetHeight(150)
			self.PostUpdatePower = updatePower -- let the colors be
	-- other

			self.CombatFeedbackText:SetPoint("CENTER", self, "CENTER", 0, 0)
			self.CombatFeedbackText:SetParent(self.Health)
	-- debuffs
			if hidebuffs == 1 then
				self.Debuffs.size = 17.75
				self.Debuffs:SetHeight(self.Debuffs.size * 8)
				self.Debuffs:SetWidth(self.Debuffs.size)
				self.Debuffs:SetPoint("TOPRIGHT", self, "TOPLEFT", 0, 0)
				self.Debuffs.initialAnchor = "TOPRIGHT"
				self.Debuffs["growth-y"] = "DOWN"
				self.Debuffs["growth-x"] = "LEFT"
				self.Debuffs.num = 8
				self.Debuffs.spacing = 1
			else
				self.Debuffs:Hide()
			end
	-- leader icon
			self.Leader = self.Health:CreateTexture(nil, "OVERLAY")
			self.Leader:SetHeight(14)
			self.Leader:SetWidth(14)
			self.Leader:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0, 2)
			self.Leader:SetTexture"Interface\\GroupFrame\\UI-Group-LeaderIcon"
	-- PvP Icon
			local pvp = self.Health:CreateTexture(nil, "OVERLAY")
			pvp:SetPoint("CENTER", self.Portrait, "CENTER", 8, -10)
			pvp:SetHeight(50)
			pvp:SetWidth(50)
			self.PvP = pvp
			self.PvP:SetParent(self.ICONS)
	-- ready check
			self.ReadyCheck = self.Health:CreateTexture(nil, 'OVERLAY')
			self.ReadyCheck:SetPoint("RIGHT", self.Portrait, "RIGHT", -2, 0)
			self.ReadyCheck:SetHeight(24)
			self.ReadyCheck:SetWidth(24)
	-- auras
			if unit=="player" then
	-- Combat icon
				self.Combat = self.Health:CreateTexture(nil, 'OVERLAY')
				self.Combat:SetHeight(14)
				self.Combat:SetWidth(14)	
				self.Combat:SetTexCoord(0.58, 0.90, 0.08, 0.41)
				self.Combat:SetPoint("TOPLEFT", self.Health, "TOPLEFT", 2, -1)
	-- resting icon
				self.Resting = self.Health:CreateTexture(nil, 'OVERLAY')
				self.Resting:SetHeight(24)
				self.Resting:SetWidth(24)
				self.Resting:SetPoint("TOPLEFT", self.Portrait, "TOPLEFT", 2, -22)
				self.Resting:SetTexture('Interface\\CharacterFrame\\UI-StateIcon')
				self.Resting:SetTexCoord(0,0.5,0,0.421875)
				self.Resting:SetParent(self.ICONS)
	-- afk icon
				local afkIcon = self.Health:CreateTexture(nil, "OVERLAY")
				self.AFKIcon = afkIcon
				self.AFKIconTexture = "Interface\\AddOns\\oUF_AFKIcon\\Icon.tga"
				self.AFKIcon:SetParent(self.ICONS)
				afkIcon:SetPoint("BOTTOMLEFT", self.Portrait, "BOTTOMLEFT", 2, 22)	  
				afkIcon:SetWidth(24)
				afkIcon:SetHeight(24)
	-- buffs
				if hidebuffs == 1 then
					self.Auras.buffFilter= "HELPFUL"
					self.Auras.size = 17.75
					self.Auras.gap = true
					self.Auras:SetHeight(self.Auras.size * 8)
					self.Auras:SetWidth(self.Auras.size)
					self.Auras:SetPoint("TOPLEFT", self, "TOPRIGHT", 0, 0)
					self.Auras.initialAnchor = "TOPLEFT"
					self.Auras["growth-x"] = "RIGHT"
					self.Auras["growth-y"] = "DOWN"
					self.Auras.numBuffs = 8
					self.Auras.numDebuffs = 0
					self.Auras.spacing = 1
					self.Enchant.initialAnchor = "TOPLEFT"
					self.Enchant["growth-x"] = "RIGHT"
					self.Enchant["growth-y"] = "DOWN"
					self.Enchant.showCD = true
					self.Enchant.size = 28
					self.Enchant.spacing = 2
					self.Enchant:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 2, -30)
					self.Enchant:SetPoint("BOTTOMRIGHT", UIParent, "TOPRIGHT", 30, -90)
				else
					self.Auras:Hide()
				end
			else
				self.Auras.buffFilter= "HELPFUL|SELF"
				self.Auras.size = 17.75
				self.Auras.gap = true
				self.Auras:SetHeight(self.Auras.size * 8)
				self.Auras:SetWidth(self.Auras.size)
				self.Auras:SetPoint("TOPLEFT", self, "TOPRIGHT", 0, 0)
				self.Auras.initialAnchor = "TOPLEFT"
				self.Auras["growth-x"] = "RIGHT"
				self.Auras["growth-y"] = "DOWN"
				self.Auras.numBuffs = 8
				self.Auras.numDebuffs = 0
				self.Auras.spacing = 1
			end
			if unit=="target" then
				self.CPoints = {}
				self.CPoints.unit = PlayerFrame.unit
				for i = 1, 5 do
					self.CPoints[i] = self.Power:CreateTexture(nil, "OVERLAY")
					self.CPoints[i]:SetHeight(5)
					self.CPoints[i]:SetWidth(14.6)
					self.CPoints[i]:SetTexture(texture)
					if i == 1 then
						self.CPoints[i]:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 2, 0)
						self.CPoints[i]:SetVertexColor(196/255,  30/255,  60/255, 1)
					else
						self.CPoints[i]:SetPoint("LEFT", self.CPoints[i-1], "RIGHT", 2, 0)
					end
				end
				self.CPoints[2]:SetVertexColor(225/255, 136/255, 71/255, 1)
				self.CPoints[3]:SetVertexColor(255/255, 243/255,  82/255, 1)
				self.CPoints[4]:SetVertexColor(213/255, 228/255, 99/255, 1)
				self.CPoints[5]:SetVertexColor(171/255, 214/255, 116/255, 1)
				self:RegisterEvent("UNIT_COMBO_POINTS", UpdateCPoints)
			elseif(self:GetParent():GetName():match"oUF_Party") then
				self:SetScale(scaleP)
			elseif unit=="player" then
	-- oUF_PowerSpark support
				self.Spark = self.Power:CreateTexture(nil, "OVERLAY")
				self.Spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
				self.Spark:SetVertexColor(1, 1, 1, 1)
				self.Spark:SetBlendMode("ADD")
				self.Spark:SetHeight(self.Power:GetHeight()*1.5)
				self.Spark:SetWidth(4)
	-- Rune Bar
				if playerClass=="DEATHKNIGHT" then
					local rune = CreateFrame("Frame", nil, self)
					rune:SetBackdrop({bgFile = texture, insets = {top = 0, left = -2, bottom = -2, right = -2},})
					rune:SetBackdropColor(0, 0, 0)

	 				rune:SetFrameStrata("MEDIUM")
					rune:SetFrameLevel(3)

					rune:SetHeight(6)
					rune:SetWidth(81)
	 	
					rune.spacing = 2
					rune.anchor = "TOPLEFT"
					rune.growth = "RIGHT"
					oUF.colors.runes = {
						{ 0.77, 0.12, 0.23  },
						{ 0.9, 0.7, 0.1 },
						{ 0, 0.4, 0.7 },
						{ 0.8, 0.1, 1 },
					}
					rune:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 2, 0)
					for i = 1, 6 do
						local bar = CreateFrame("Statusbar", nil, rune)
						bar:SetStatusBarTexture(texture)
						bar.bg = bar:CreateTexture(nil, "BACKGROUND")
						bar.bg:SetTexture(texture)
						bar.bg:SetAllPoints(bar)
						bar.bg:SetAlpha(0.3)
					 	if i == 1 or i == 2 then
							bar:SetStatusBarColor(0.77, 0.12, 0.23)
						elseif i == 3 or i == 4 then
							bar:SetStatusBarColor(0.9, 0.7, 0.1)
						elseif i == 5 or i == 6 then
							bar:SetStatusBarColor(0, 0.4, 0.7)
						end
						rune[i] = bar
						
					end

					self.Runes = rune
					self.Runes.height = 6
					self.Runes.width = 11.833
				end

	-- Totem Bar	
				if IsAddOnLoaded("oUF_TotemBar") and playerClass == "SHAMAN" then
					self.TotemBar = {}
					for i = 1, 4 do
						self.TotemBar[i] = CreateFrame("StatusBar", nil, self)

		 				self.TotemBar[i]:SetFrameStrata("MEDIUM")
						self.TotemBar[i]:SetFrameLevel(3)

						self.TotemBar[i]:SetHeight(10)
						self.TotemBar[i]:SetWidth(18.75)
						if (i == 1) then
							self.TotemBar[i]:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 2, 0)
						elseif (i ==2) then
							self.TotemBar[i]:SetPoint("BOTTOMLEFT", self.TotemBar[1], "BOTTOMRIGHT", 2, 0)
						elseif (i == 3) then
							self.TotemBar[i]:SetPoint("BOTTOMLEFT", self.TotemBar[2], "BOTTOMRIGHT", 2, 0)
						elseif (i == 4) then
							self.TotemBar[i]:SetPoint("BOTTOMLEFT", self.TotemBar[3], "BOTTOMRIGHT", 2, 0)
						end
						self.TotemBar[i]:SetStatusBarTexture(texture)
						self.TotemBar[i]:SetBackdrop({bgFile = texture, insets = {top = 0, left = -2, bottom = -2, right = -2},})
						self.TotemBar[i]:SetBackdropColor(0, 0, 0)
						self.TotemBar[i]:SetMinMaxValues(0, 1)
						self.TotemBar[i].destroy = true				
						self.TotemBar[i].bg = self.TotemBar[i]:CreateTexture(nil, "BORDER")
						self.TotemBar[i].bg:SetAllPoints(self.TotemBar[i])
						self.TotemBar[i].bg:SetTexture(texture)
						self.TotemBar[i].bg.multiplier = 0.25
					end
				end
	
	-- Druid Mana Bar
				if playerClass=="DRUID" then
					DMana:SetParent(self)
					DMana:SetFrameStrata("MEDIUM")
					DMana:SetFrameLevel(3)
					DMana:SetPoint ("TOPLEFT", self, "BOTTOMLEFT", 2, 0)
					DMana:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -2, -8)
					DMana:SetHeight(6)
					DMana:SetWidth(81)
					DMana:SetStatusBarTexture(texture)
					DMana:SetAlpha(1)
					DMana.bg = DMana:CreateTexture(nil, "BORDER")
					DMana.bg:SetAllPoints(DMana)
					DMana.bg:SetAlpha(0.50)
					DMana.bg:SetTexture(texture)
					table.insert(self.__elements, updateDMana)
					self:RegisterEvent('UNIT_MANA', updateDMana)
					self:RegisterEvent('UPDATE_SHAPESHIFT_FORM', updateDMana)
	-- backdrop
					DMana.BG = DMana:CreateTexture("bg", "BACKGROUND")
					DMana.BG:SetPoint("TOPLEFT",DMana,"TOPLEFT",-2,2)
					DMana.BG:SetPoint("BOTTOMRIGHT",DMana,"BOTTOMRIGHT",2,-2)
					DMana.BG:SetTexture(texture)
					DMana.BG:SetVertexColor(0, 0, 0, 0.8)
				end
	
	-- druid mana text
				if playerClass=="DRUID" then
					local value = self.Power:CreateFontString(nil, 'OVERLAY')
					value:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT", 0, -10)		
					value:SetFont(font, fontsize, "OUTLINE")
					value.frequentUpdates = true
					self:Tag(value, '[druidpower]')

					value:SetParent(self.Health)
					table.insert(self.__elements, updateDruidPower)
					self:RegisterEvent('UNIT_MANA', updateDruidPower)
					self:RegisterEvent('UNIT_RAGE', updateDruidPower)
					self:RegisterEvent('UNIT_ENERGY', updateDruidPower)
					self:RegisterEvent('UPDATE_SHAPESHIFT_FORM', updateDruidPower)
				end

	--rep and xp bar
				if RepBar == 0 then
					if IsAddOnLoaded("oUF_Experience") and UnitLevel("Player") < 80 then
							self.Experience = CreateFrame("StatusBar", self:GetName().."_Experience", self)
							self.Experience:SetHeight(XPRepHei)
							self.Experience:SetWidth(XPRepWid)
							self.Experience:SetPoint(XPRepAFrom, XPRepAFrame, XPRepATo, XPRepXPos, XPRepYPos)
							self.Experience:SetStatusBarTexture(texture)
							self.Experience:SetStatusBarColor(0.1, 0.57, 0.1)
							self.Experience:SetBackdrop({bgFile = texture, insets = {top = -1, left = -1, bottom = -1, right = -1},})
							self.Experience:SetBackdropColor(0, 0, 0)
							self.Experience.bg = self.Experience:CreateTexture(nil, "BORDER")
							self.Experience.bg:SetAllPoints(self.Experience)
							self.Experience.bg:SetTexture(texture)
							self.Experience.bg:SetVertexColor(0.15, 0.15, 0.15)
							self.Experience.MouseOver = false
							self.Experience.Tooltip = true
					end
				elseif RepBar == 1 then
					if IsAddOnLoaded("oUF_Experience") and UnitLevel("Player") < 80 then
						if IsAddOnLoaded("oUF_Reputation") then
							self.Experience = CreateFrame("StatusBar", self:GetName().."_Experience", self)
							self.Experience:SetHeight(XPRepHei)
							self.Experience:SetWidth(XPRepHalfWid)
							self.Experience:SetPoint(XPRepAFrom, XPRepAFrame, XPRepATo, XPRepXPos-(XPRepHalfWid/2), XPRepYPos)
							self.Experience:SetStatusBarTexture(texture)
							self.Experience:SetStatusBarColor(0.1, 0.57, 0.1)
							self.Experience:SetBackdrop({bgFile = texture, insets = {top = -1, left = -1, bottom = -1, right = -1},})
							self.Experience:SetBackdropColor(0, 0, 0)
							self.Experience.bg = self.Experience:CreateTexture(nil, "BORDER")
							self.Experience.bg:SetAllPoints(self.Experience)
							self.Experience.bg:SetTexture(texture)
							self.Experience.bg:SetVertexColor(0.15, 0.15, 0.15)
							self.Experience.MouseOver = false
							self.Experience.Tooltip = true
						else
							self.Experience = CreateFrame("StatusBar", self:GetName().."_Experience", self)
							self.Experience:SetHeight(XPRepHei)
							self.Experience:SetWidth(XPRepWid)
							self.Experience:SetPoint(XPRepAFrom, XPRepAFrame, XPRepATo, XPRepXPos, XPRepYPos)
							self.Experience:SetStatusBarTexture(texture)
							self.Experience:SetStatusBarColor(0.1, 0.57, 0.1)
							self.Experience:SetBackdrop({bgFile = texture, insets = {top = -1, left = -1, bottom = -1, right = -1},})
							self.Experience:SetBackdropColor(0, 0, 0)
							self.Experience.bg = self.Experience:CreateTexture(nil, "BORDER")
							self.Experience.bg:SetAllPoints(self.Experience)
							self.Experience.bg:SetTexture(texture)
							self.Experience.bg:SetVertexColor(0.15, 0.15, 0.15)
							self.Experience.MouseOver = false
							self.Experience.Tooltip = true
						end
					end
		-- Reputation
					if IsAddOnLoaded("oUF_Reputation") then
						if UnitLevel("Player") == 80 then
							self.Reputation = CreateFrame("StatusBar", self:GetName().."_Reputation", self)
							self.Reputation:SetHeight(XPRepHei)
							self.Reputation:SetWidth(XPRepWid)
							self.Reputation:SetPoint(XPRepAFrom, XPRepAFrame, XPRepATo, XPRepXPos, XPRepYPos)
							self.Reputation:SetStatusBarTexture(texture)
							self.Reputation:SetStatusBarColor(0.2, 0.2, 0.57)
							self.Reputation:SetBackdrop({bgFile = texture, insets = {top = -1, left = -1, bottom = -1, right = -1},})
							self.Reputation:SetBackdropColor(0, 0, 0)
							self.Reputation.bg = self.Reputation:CreateTexture(nil, "BORDER")
							self.Reputation.bg:SetAllPoints(self.Reputation)
							self.Reputation.bg:SetTexture(texture)
							self.Reputation.bg:SetVertexColor(0.15, 0.15, 0.15)
							self.Reputation.PostUpdate = UpdateReputationColor
							self.Reputation.Tooltip = true
						else
							if IsAddOnLoaded("oUF_Experience") then
								self.Reputation = CreateFrame("StatusBar", self:GetName().."_Reputation", self)
								self.Reputation:SetHeight(XPRepHei)
								self.Reputation:SetWidth(XPRepHalfWid)
								self.Reputation:SetPoint("BOTTOMLEFT", self.Experience, "BOTTOMRIGHT", 2, 0)
								self.Reputation:SetStatusBarTexture(texture)
								self.Reputation:SetStatusBarColor(0.2, 0.2, 0.57)
								self.Reputation:SetBackdrop({bgFile = texture, insets = {top = -1, left = -1, bottom = -1, right = -1},})			
								self.Reputation:SetBackdropColor(0, 0, 0)
								self.Reputation.bg = self.Reputation:CreateTexture(nil, "BORDER")
								self.Reputation.bg:SetAllPoints(self.Reputation)
								self.Reputation.bg:SetTexture(texture)
								self.Reputation.bg:SetVertexColor(0.15, 0.15, 0.15)
								self.Reputation.PostUpdate = UpdateReputationColor
								self.Reputation.Tooltip = true
							else
								self.Reputation = CreateFrame("StatusBar", self:GetName().."_Reputation", self)
								self.Reputation:SetHeight(XPRepHei)
								self.Reputation:SetWidth(XPRepWid)
								self.Reputation:SetPoint(XPRepAFrom, XPRepAFrame, XPRepATo, XPRepXPos, XPRepYPos)
								self.Reputation:SetStatusBarTexture(texture)
								self.Reputation:SetStatusBarColor(0.2, 0.2, 0.57)
								self.Reputation:SetBackdrop({bgFile = texture, insets = {top = -1, left = -1, bottom = -1, right = -1},})		
								self.Reputation:SetBackdropColor(0, 0, 0)
								self.Reputation.bg = self.Reputation:CreateTexture(nil, "BORDER")
								self.Reputation.bg:SetAllPoints(self.Reputation)
								self.Reputation.bg:SetTexture(texture)
								self.Reputation.bg:SetVertexColor(0.15, 0.15, 0.15)
								self.Reputation.PostUpdate = UpdateReputationColor
								self.Reputation.Tooltip = true
							end
						end
					end
				end  --ends if the repbar variable is 0 or 1 
			end
			self.MoveableFrames = true
		end
	end


-- ------------------------------------------------------
-- pet, pet target, focus, focus target, target target
-- ------------------------------------------------------
	if unit=="pet" or unit=="pettarget" or unit=="targettarget" or unit=="targettargettarget" or unit=="focus" or unit=="focustarget" then
		self.Level:Hide()
		self.Health.value:Hide()
		self.Power.value:Hide()
		self.Name:Hide()
		if unit=="pet" then
			if playerClass=="HUNTER" then
				self.Health.colorTapping = false
				self.Health.colorClass = false
				self.Health.colorReaction = false
				self.Health.colorDisconnected = false
				self.Health.colorHappiness = true
				self.PostUpdateHealth = updateHealth
			else
				self.Health.colorTapping = false
				self.Health.colorClass = false
				self.Health.colorReaction = true
				self.Health.colorDisconnected = false
				self.Health.colorHappiness = false
				self.PostUpdateHealth = updateHealth
			end
			self.Health:SetPoint("TOPLEFT", self, "TOPLEFT", 2, -2)
--			self.Health:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -4, 0)
			self.Power:SetPoint("TOPLEFT", self.Health, "TOPRIGHT", 2, 0)
--			self.Power:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", 0, 0)
			self.Health:SetWidth(7)
			self.Health:SetHeight(70)
			self.Power:Show()
			self.Power:SetWidth(5)
			self.Power:SetHeight(70)
			self.Power.colorTapping = false
			self.Power.colorClass = true
			self.Power.colorReaction = true
			self.Power.colorDisconnected = false
			self.Power.colorHappiness = true
			self.PostUpdatePower = updatePower -- let the colors be
			self:SetWidth(18)
			self:SetHeight(74)
		else
			self.Health.colorTapping = true
			self.Health.colorClass = true
			self.Health.colorReaction = true
			self.Health.colorDisconnected = true
			self.PostUpdateHealth = updateHealth
			self.PostUpdatePower = updatePower -- let the colors be
			self.Health:SetPoint("TOPLEFT", self, "TOPLEFT", 2, -2)
			self.Health:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -2, 2)
			self.Power:Hide()
			self.Health:SetWidth(10)
			self.Health:SetHeight(70)
			self:SetWidth(14)
			self:SetHeight(74)
		end

		self.CombatFeedbackText:Hide()
-- auras
		self.Debuffs:Hide()
		if unit=="focus" then
			self.Auras = CreateFrame("Frame", nil, self)
			self.Auras.buffFilter= "SELF|RAID"
			self.Auras.size = 15
			self.Auras:SetHeight(self.Auras.size * 3)
			self.Auras:SetWidth(self.Auras.size)
			self.Auras:SetPoint("TOPLEFT", self, "TOPRIGHT", 0, 0)
			self.Auras.initialAnchor = "TOPLEFT"
			self.Auras["growth-x"] = "RIGHT"
			self.Auras["growth-y"] = "DOWN"
			self.Auras.numBuffs = 3
			self.Auras.numDebuffs = 0
			self.Auras.spacing = 1
			self.MoveableFrames = true
		else
			self.Auras:Hide()
			self.MoveableFrames = true
		end
	end

-- -------
-- raid
-- -------
	if (self:GetParent():GetName():match"oUF_Raid") then
		self:SetScale(scaleR)
		if healMode==1 then
			if(self:GetParent():GetName():match"oUF_Raid") and (self:GetAttribute('unitsuffix') == 'pet') then
				self.Level:Hide()
				self.Health:SetPoint("TOPLEFT", self, "TOPLEFT", 2, -2)
				self.Health.value:Hide()
				self.Power.value:Hide()
				self.Name:Hide()
				self.Health.colorTapping = false
				self.Health.colorClass = false
				self.Health.colorReaction = true
				self.Health.colorDisconnected = false
				self.PostUpdateHealth = updateHealth
				self:SetWidth(14)
				self:SetHeight(25)
				self.Health:SetWidth(10)
				self.Health:SetHeight(21)
				self.CombatFeedbackText:Hide()
				self.Power:Hide()
				self.Debuffs:Hide()
				self.Auras:Hide()
				self.MoveableFrames = true
			else
				self.Level:Hide()
				self.Health:SetPoint("TOPLEFT", self, "TOPLEFT", 2, -2)
				self.Health.value:Hide()
				self.Power.value:Hide()
				self.Name:Hide()
				self.Health.colorTapping = true
				self.Health.colorClass = true
				self.Health.colorReaction = true
				self.Health.colorDisconnected = true
				self.PostUpdateHealth = updateHealth
				self.Power:SetPoint("TOPLEFT", self.Health, "TOPRIGHT", 1, 0)
				self.Power:SetWidth(8)
				self.Power:SetHeight(51)
				self.Power.colorTapping = false
				self.Power.colorClass = true
				self.Power.colorReaction = false
				self.Power.colorDisconnected = false
				self.PostUpdatePower = updatePower -- let the colors be
				self:SetWidth(23)
				self:SetHeight(55)
				self.Health:SetWidth(10)
				self.Health:SetHeight(51)
				self.CombatFeedbackText:Hide()
				self.RaidIcon:SetPoint("TOPRIGHT", self, "TOPLEFT", -1, 0)
		-- auras
				self.Debuffs:Hide()
				self.Auras:Hide()
				self.MoveableFrames = true
			end
		else
			if(self:GetParent():GetName():match"oUF_Raid") and (self:GetAttribute('unitsuffix') == 'pet') then
				self.Level:Hide()
				self.Health:SetPoint("TOPLEFT", self, "TOPLEFT", 2, -2)
				self.Health.value:Hide()
				self.Power.value:Hide()
				self.Name:Hide()
				self.Health.colorTapping = false
				self.Health.colorClass = false
				self.Health.colorReaction = true
				self.Health.colorDisconnected = false
				self.PostUpdateHealth = updateHealth
				self.PostUpdatePower = updatePower -- let the colors be
				self:SetWidth(14)
				self:SetHeight(25)
				self.Health:SetWidth(10)
				self.Health:SetHeight(21)
				self.CombatFeedbackText:Hide()
				self.Power:Hide()
		-- auras
				self.Debuffs:Hide()
				self.Auras:Hide()
				self.MoveableFrames = true
			else
				self.Level:Hide()
				self.Health:SetPoint("TOPLEFT", self, "TOPLEFT", 2, -2)
				self.Health.value:Hide()
				self.Power.value:Hide()
				self.Name:Hide()
				self.Health.colorTapping = true
				self.Health.colorClass = true
				self.Health.colorReaction = true
				self.Health.colorDisconnected = true
				self.PostUpdateHealth = updateHealth
				self.PostUpdatePower = updatePower -- let the colors be
				self:SetWidth(14)
				self:SetHeight(55)
				self.Health:SetWidth(10)
				self.Health:SetHeight(51)
				self.CombatFeedbackText:Hide()
				self.Power:Hide()
				self.RaidIcon:SetPoint("TOPRIGHT", self, "TOPLEFT", -1, 0)
		-- auras
				self.Debuffs:Hide()
				self.Auras:Hide()
				self.MoveableFrames = true
			end
		end
	end

-- ------------------------------------
-- castbars
-- ------------------------------------
-- testing for Castbar
	CBs = CreateFrame("Frame", nil, UIParent)
	CBs:SetFrameStrata("MEDIUM")
	CBs:SetFrameLevel(10)
	CBs:SetPoint("TOPLEFT", UIParent, "CENTER", -75, -150)
	CBs:SetPoint("BOTTOMRIGHT", UIParent, "CENTER", 75, -194)

	if(unit == 'player' or unit == 'target' or unit == 'focus') then
	    self.Castbar = CreateFrame('StatusBar', nil, self)
	    self.Castbar:SetStatusBarTexture(texture)
		self.Castbar:SetFrameStrata("BACKGROUND")
		self.Castbar:SetFrameLevel(3)
		if(unit == "player") then
			self.Castbar:SetStatusBarColor(0.2, 0.9, 0.1, 0.6)
			self.Castbar:SetPoint("TOPLEFT", CBs, "TOPLEFT", 0, 0)
			self.Castbar:SetPoint("BOTTOMRIGHT", CBs, "TOPRIGHT", 0, -16)
			self.Castbar.SafeZone = self.Castbar:CreateTexture(nil,"ARTWORK")
			self.Castbar.SafeZone:SetTexture(texture)
			self.Castbar.SafeZone:SetVertexColor(.75,.10,.10,.6)
			self.Castbar.SafeZone:SetPoint("TOPRIGHT")
			self.Castbar.SafeZone:SetPoint("BOTTOMRIGHT")
		elseif(unit == "target") then
			self.Castbar:SetStatusBarColor(0.9, 0.1, 0.2, 0.6)
			self.Castbar:SetPoint("TOPLEFT", CBs, "TOPLEFT", 0, -18)
			self.Castbar:SetPoint("BOTTOMRIGHT", CBs, "TOPRIGHT", 0, -30)
		elseif(unit == "focus") then
			self.Castbar:SetStatusBarColor(0.2, 0.1, 0.9, 0.6)
			self.Castbar:SetPoint("TOPLEFT", CBs, "TOPLEFT", 0, -32)
			self.Castbar:SetPoint("BOTTOMRIGHT", CBs, "TOPRIGHT", 0, -44)
		end
		self.Castbar:SetBackdropColor(0, 0, 0, 0.9)
		self.Castbar.Text = self.Castbar:CreateFontString(nil, 'OVERLAY')
		self.Castbar.Text:SetPoint("TOPLEFT", self.Castbar, "TOPLEFT")
		self.Castbar.Text:SetPoint("BOTTOMRIGHT", self.Castbar, "BOTTOMRIGHT")
		self.Castbar.Text:SetFont(font, 10)
		self.Castbar.Text:SetShadowOffset(1, -1)
		self.Castbar.Text:SetTextColor(1, 1, 1)
		self.Castbar.Text:SetJustifyH('LEFT')
		self.Castbar.Time = self.Castbar:CreateFontString(nil, 'OVERLAY')
		self.Castbar.Time:SetPoint('RIGHT', self.Castbar, -5, 0)
		self.Castbar.Time:SetFont(font, 10)
		self.Castbar.Time:SetTextColor(1, 1, 1)
		self.Castbar.Time:SetJustifyH('RIGHT')
-- backdrop
		self.Castbar.BG = self.Castbar:CreateTexture("bg", "BACKGROUND")
		self.Castbar.BG:SetAllPoints(self.Castbar)
		self.Castbar.BG:SetTexture(texture)
		self.Castbar.BG:SetVertexColor(0, 0, 0, 0.8)
	end

-------
end
-------
-- ------------------------------------------------------------------------
-- spawning the frames
-- ------------------------------------------------------------------------

-- normal frames
oUF:RegisterStyle("oUF_WTF", func)
oUF:SetActiveStyle("oUF_WTF")

local player = oUF:Spawn("player", "oUF_Player")
player:SetPoint("TOPRIGHT", UIParent, "CENTER", -40, -220)
player:SetScale(scalePl)

local target = oUF:Spawn("target", "oUF_Target")
target:SetPoint("TOPLEFT", UIParent, "CENTER", 40, -220)
target:SetScale(scaleT)

local pet = oUF:Spawn("pet", "oUF_Pet")
pet:SetPoint("TOPRIGHT", player, "TOPLEFT", -20, 0)
pet:SetScale(scalePl)

local pettarget = oUF:Spawn("pettarget", "oUF_PetTarget")
pettarget:SetPoint("BOTTOMRIGHT", player, "BOTTOMLEFT", -20, 0)
pettarget:SetScale(scalePl)

local tot = oUF:Spawn("targettarget", "oUF_TargetTarget")
tot:SetPoint("TOPLEFT", target, "TOPRIGHT", 20, 0)
tot:SetScale(scaleT)

local totot = oUF:Spawn("targettargettarget", "oUF_TargetTargetTarget")
totot:SetPoint("BOTTOMLEFT", target, "BOTTOMRIGHT", 20, 0)
totot:SetScale(scaleT)

local focus = oUF:Spawn("focus", "oUF_Focus")
focus:SetPoint("TOPLEFT", player, "TOPRIGHT", 20, 0)
focus:SetScale(scalePl)

local tof = oUF:Spawn("focustarget", "oUF_FocusTarget")
tof:SetPoint("BOTTOMLEFT", player, "BOTTOMRIGHT", 20, 0)
tof:SetScale(scalePl)

local party = oUF:Spawn("header", "oUF_Party")
party:SetPoint("TOPRIGHT", player, "TOPLEFT", -80, 35) -- old settings: "topleft", uiparent, "center", -270, -185
party:SetManyAttributes(
	"showParty", true,
	"yOffset", -40,
	"xOffset", 0,
	'maxColumns', 2,
	'unitsPerColumn', 2,
	'columnAnchorPoint', 'RIGHT',
	'columnSpacing', 65, -- was 600
	"template", "oUF_WTFParty"
)
party:Show()

local raid = {}
for i = 1, 8 do
	local raidgroup = oUF:Spawn('header', 'oUF_Raid'..i)
	raidgroup:SetManyAttributes(
		'groupFilter', tostring(i), 
		'showRaid', true, 
		'yOffSet', -2, 
		"point", "TOP", 
		"template", "oUF_WTFRaid"
	)
	table.insert(raid, raidgroup)
	if healMode==1 then
		if(i==1) then
			raidgroup:SetPoint('BOTTOMLEFT', UIParent, 'BOTTOMLEFT', 30, 150)
		elseif(i==3) then
			raidgroup:SetPoint('BOTTOMLEFT', UIParent, 'BOTTOMLEFT', 79, 150)
		elseif(i==5) then
			raidgroup:SetPoint('BOTTOMLEFT', UIParent, 'BOTTOMLEFT', 128, 150)
		elseif(i==7) then
			raidgroup:SetPoint('BOTTOMLEFT', UIParent, 'BOTTOMLEFT', 177, 150)
		else
			raidgroup:SetPoint('BOTTOM', raid[i-1], 'TOP', 0, 5)
		end
	else
		if(i==1) then
			raidgroup:SetPoint('BOTTOMLEFT', UIParent, 'BOTTOMLEFT', 30, 30)
		elseif(i==4) then
			raidgroup:SetPoint('BOTTOMLEFT', UIParent, 'BOTTOMLEFT', 79, 30)
		elseif(i==7) then
			raidgroup:SetPoint('BOTTOMLEFT', UIParent, 'BOTTOMLEFT', 128, 30)
		else
			raidgroup:SetPoint('BOTTOM', raid[i-1], 'TOP', 0, 5)
		end
	end
end

-- party toggle in raid
	local partyToggle = CreateFrame('Frame')
	partyToggle:RegisterEvent('PLAYER_LOGIN')
	partyToggle:RegisterEvent('RAID_ROSTER_UPDATE')
	partyToggle:RegisterEvent('PARTY_LEADER_CHANGED')
	partyToggle:RegisterEvent('PARTY_MEMBERS_CHANGED')
	partyToggle:SetScript('OnEvent', function(self)
		if(InCombatLockdown()) then
			self:RegisterEvent('PLAYER_REGEN_ENABLED')
		else
			self:UnregisterEvent('PLAYER_REGEN_ENABLED')
			if(GetNumRaidMembers() > 0) then
				if showPartyinRaid==1 then
					party:Show()
				else
					party:Hide()
				end
				if showRaid==1 then
					for i,v in ipairs(raid) do v:Show() end
				else
					for i,v in ipairs(raid) do v:Hide() end
				end
			else
				party:Show()
				for i,v in ipairs(raid) do v:Hide() end
			end
		end
end)
